gi-gdkpixbuf-2.0.32: GdkPixbuf bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.GdkPixbuf.Objects.PixbufAnimationIter

Contents

- Exported types
- Methods
  - advance
  - getDelayTime
  - getPixbuf
  - onCurrentlyLoadingFrame

Description

An opaque object representing an iterator which points to a certain position in an animation.

Synopsis

- newtype PixbufAnimationIter = PixbufAnimationIter (ManagedPtr PixbufAnimationIter)
- class (GObject o, IsDescendantOf PixbufAnimationIter o) => IsPixbufAnimationIter o
- toPixbufAnimationIter :: (MonadIO m, IsPixbufAnimationIter o) => o -> m PixbufAnimationIter
- pixbufAnimationIterAdvance :: (HasCallStack, MonadIO m, IsPixbufAnimationIter a) => a -> Maybe TimeVal -> m Bool
- pixbufAnimationIterGetDelayTime :: (HasCallStack, MonadIO m, IsPixbufAnimationIter a) => a -> m Int32
- pixbufAnimationIterGetPixbuf :: (HasCallStack, MonadIO m, IsPixbufAnimationIter a) => a -> m Pixbuf
- pixbufAnimationIterOnCurrentlyLoadingFrame :: (HasCallStack, MonadIO m, IsPixbufAnimationIter a) => a -> m Bool

# Exported types

newtype PixbufAnimationIter Source #

Memory-managed wrapper type.

Constructors

PixbufAnimationIter (ManagedPtr PixbufAnimationIter) |

#### Instances

Instances details

Eq PixbufAnimationIter Source # |
Instance details Defined in GI.GdkPixbuf.Objects.PixbufAnimationIter Methods (==) :: PixbufAnimationIter -> PixbufAnimationIter -> Bool Source # (/=) :: PixbufAnimationIter -> PixbufAnimationIter -> Bool Source #
GObject PixbufAnimationIter Source # |
Instance details Defined in GI.GdkPixbuf.Objects.PixbufAnimationIter
ManagedPtrNewtype PixbufAnimationIter Source # |
Instance details Defined in GI.GdkPixbuf.Objects.PixbufAnimationIter Methods toManagedPtr :: PixbufAnimationIter -> ManagedPtr PixbufAnimationIter Source #
TypedObject PixbufAnimationIter Source # |
Instance details Defined in GI.GdkPixbuf.Objects.PixbufAnimationIter Methods glibType :: IO GType Source #
HasParentTypes PixbufAnimationIter Source # |
Instance details Defined in GI.GdkPixbuf.Objects.PixbufAnimationIter
IsGValue (Maybe PixbufAnimationIter) Source # | Convert `PixbufAnimationIter` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.GdkPixbuf.Objects.PixbufAnimationIter Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe PixbufAnimationIter -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe PixbufAnimationIter) Source #
type ParentTypes PixbufAnimationIter Source # |
Instance details Defined in GI.GdkPixbuf.Objects.PixbufAnimationIter type ParentTypes PixbufAnimationIter = '[Object]

class (GObject o, IsDescendantOf PixbufAnimationIter o) => IsPixbufAnimationIter o Source #

Type class for types which can be safely cast to `PixbufAnimationIter`, for instance with `toPixbufAnimationIter`.

#### Instances

Instances details

(GObject o, IsDescendantOf PixbufAnimationIter o) => IsPixbufAnimationIter o Source # |
Instance details Defined in GI.GdkPixbuf.Objects.PixbufAnimationIter

toPixbufAnimationIter :: (MonadIO m, IsPixbufAnimationIter o) => o -> m PixbufAnimationIter Source #

Cast to `PixbufAnimationIter`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

advance, bindProperty, bindPropertyFull, forceFloating, freezeNotify, getv, isFloating, notify, notifyByPspec, onCurrentlyLoadingFrame, ref, refSink, runDispose, stealData, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getData, getDelayTime, getPixbuf, getProperty, getQdata.

#### Setters

setData, setDataFull, setProperty.

## advance

pixbufAnimationIterAdvance Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbufAnimationIter a) |
=> a | `iter`: a `PixbufAnimationIter`
-> Maybe TimeVal | `currentTime`: current time
-> m Bool | Returns: `TRUE` if the image may need updating

Deprecated: (Since version 2.44)Use a different image loading library for animatable assets

Possibly advances an animation to a new frame.

Chooses the frame based on the start time passed to `pixbufAnimationGetIter`.

`currentTime` would normally come from `getCurrentTime`, and must be greater than or equal to the time passed to `pixbufAnimationGetIter`, and must increase or remain unchanged each time `pixbufAnimationIterGetPixbuf` is called. That is, you can't go backward in time; animations only play forward.

As a shortcut, pass `NULL` for the current time and `getCurrentTime` will be invoked on your behalf. So you only need to explicitly pass `currentTime` if you're doing something odd like playing the animation at double speed.

If this function returns `FALSE`, there's no need to update the animation display, assuming the display had been rendered prior to advancing; if `TRUE`, you need to call `pixbufAnimationIterGetPixbuf` and update the display with the new pixbuf.

## getDelayTime

pixbufAnimationIterGetDelayTime Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbufAnimationIter a) |
=> a | `iter`: an animation iterator
-> m Int32 | Returns: delay time in milliseconds (thousandths of a second)

Deprecated: (Since version 2.44)Use a different image loading library for animatable assets

Gets the number of milliseconds the current pixbuf should be displayed, or -1 if the current pixbuf should be displayed forever.

The `g_timeout_add()` function conveniently takes a timeout in milliseconds, so you can use a timeout to schedule the next update.

Note that some formats, like GIF, might clamp the timeout values in the image file to avoid updates that are just too quick. The minimum timeout for GIF images is currently 20 milliseconds.

## getPixbuf

pixbufAnimationIterGetPixbuf Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbufAnimationIter a) |
=> a | `iter`: an animation iterator
-> m Pixbuf | Returns: the pixbuf to be displayed

Deprecated: (Since version 2.44)Use a different image loading library for animatable assets

Gets the current pixbuf which should be displayed.

The pixbuf might not be the same size as the animation itself (`pixbufAnimationGetWidth`, `pixbufAnimationGetHeight`).

This pixbuf should be displayed for `pixbufAnimationIterGetDelayTime` milliseconds.

The caller of this function does not own a reference to the returned pixbuf; the returned pixbuf will become invalid when the iterator advances to the next frame, which may happen anytime you call `pixbufAnimationIterAdvance`.

Copy the pixbuf to keep it (don't just add a reference), as it may get recycled as you advance the iterator.

## onCurrentlyLoadingFrame

pixbufAnimationIterOnCurrentlyLoadingFrame Source #

Arguments

:: (HasCallStack, MonadIO m, IsPixbufAnimationIter a) |
=> a | `iter`: a `PixbufAnimationIter`
-> m Bool | Returns: `TRUE` if the frame we're on is partially loaded, or the last frame

Deprecated: (Since version 2.44)Use a different image loading library for animatable assets

Used to determine how to respond to the area_updated signal on `PixbufLoader` when loading an animation.

The `::area_updated` signal is emitted for an area of the frame currently streaming in to the loader. So if you're on the currently loading frame, you will need to redraw the screen for the updated area.